<?php
/*/_____________________________________________________________________________
————————————————————————————————————————————————————————————————————————————————
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
                               InstantCMS v 1.*
                          http://www.instantcms.ru/
                    written by InstantCMS Team, 2007-2014
                produced by InstantSoft, ( www.instantsoft.ru )

                           LICENSED BY GNU/GPL v2
________________________•————————————————————————————•__________________________
————————————————————————  • M i k e •  e d i t i o n  ——————————————————————————
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯•————————————————————————————•¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/

class p_pagebar extends cmsPlugin {

/*/_____________________________________________________________________________
————————————————————————————————————————————————————————————————————————————————
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/

    public function __construct(){
        parent::__construct();

        $this-> info['plugin']          = 'p_pagebar';
        $this-> info['title']           = 'Pagebar';
        $this-> info['description']     = 'Расширенная постраничная навигация';
        $this-> info['author']          = '• Mike •';
        $this-> info['version']         = '1.10.3';
        $this-> info['type']            = 'pagebar';

        $this-> events[]                = 'GET_PAGEBAR';

        $this-> config['theme']         = "light";
        $this-> config['ofset']         = 2;
        $this-> config['type']          = 'both';
        $this-> config['title']         = 0;
        $this-> config['test']          = 0;
    }
/*/_____________________________________________________________________________
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/
    public function install(){ return parent::install(); }
/*/_____________________________________________________________________________
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/
    public function upgrade(){ return parent::upgrade(); }
/*/_____________________________________________________________________________
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/

    public function execute( $event, $item ){
        parent::execute();

         global $_LANG;

/*/_____________________________________________________________________________
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/
switch ( $event ) {
/*/_____________________________________________________________________________
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/
    case 'GET_PAGEBAR' :

    $total      = ( int ) $item[0];
    $page       = ( int ) $item[1];
    $perpage    = ( int ) $item[2];
    $link       = $item[3];
    $params     = $item[4];

    extract( $this-> config );

    if ( !isset( $theme) || !in_array( mb_strtolower( $theme ), array( 'light', 'dark' ) ) ) { $theme = 'light'; }
    if ( !isset( $ofset ) ) { $ofset = ( int ) $ofset ? $ofset : 2; }
    if ( !isset( $test ) ) { $test = ( int ) $test ? $test : 0; }
    if ( !isset( $type ) || !in_array( mb_strtolower( $type ), array( 'simple', 'ext', 'spiner', 'both' ) ) ) { $type = 'simple'; }
    if ( !isset( $title ) ) { $title = ( int ) $title ? ( bool ) $title : false; }

    $total_pages = $test ? $test : ceil( $total / $perpage );

    if ( $total_pages < 2 ) { return; }

if ( in_array( $type, array( 'simple', 'ext', 'spiner', 'both' ) ) ) {

$both = <<<_OUT
<div class="pagebar" style="text-align: center;">
    <div id="all_pages" class="mbox">
        <div class="m_row" style="width:100%;">
            <div class="m_cell">
_OUT;

if ( in_array( $type, array( 'simple', 'ext', 'both' ) ) ) {

    $title  = $title ? '<div id="pagebar_title">'. $_LANG['PAGE'] . '<strong>&nbsp;' . $page . '&nbsp;</strong>' . $_LANG['CBOX_FROM'] . ' ' . $total_pages . '</div>' : '';

$both .= <<<_OUT
                <div id="page_pages" class="mbox">
                    <div class="box">$title<div class="b_row">
_OUT;

    if ( $total_pages <= 10 ) { $ofset = 1; }
    $ofset = $ofset < 5 ? $ofset : 5;

    $max_page = $ofset + $start;
    if ( $page > $max_page ) { $start = ( $start + $page ) - $max_page; }
    if ( $page >= 1 ) {
        $max_page = ( ( $page + $ofset + 1 ) > $ofset * 2 + 3 ) ? ( $page + $ofset + 1 ) : $ofset * 2 + 3;
        $start = ( ( $total_pages - $start ) > ( $ofset * 2 ) + 1 ) ? $start : $total_pages - ( ( $ofset * 2 ) + 1 );
    }
    if ( $max_page >= $total_pages ) { $max_page = $total_pages + 1; }
    if ( $page + $ofset < ($ofset * 2) + 3 ) { $start = 1; }
    if ( $page > 1 ) {
        $href = $link;
        if ( is_array( $params ) ) {
            foreach ( $params as $param => $value ) {
                $href = str_replace( '%' . $param . '%', $value, $href );
            }
        }
        if ( $max_page > $ofset * 2 + 3 ) {
            $simple .= '<a href="' . str_replace( '%page%', 1, $href ) . '" class="b_pages" title="' . $_LANG['FIRST'] . '">1</a><div class="b_pages"> ... </div> ';
        }
    }
    for ( $i = $start; $i < $max_page; $i++ ) {
        if ( $i == $page ) {
            $simple .= '<span class="b_pages_current" style="">' . $i . '</span>';
        } else {
            $href = $link;
            if ( is_array( $params ) ) {
                foreach ( $params as $param => $value ) {
                    $href = str_replace( '%' . $param . '%', $value, $href );
                }
            }
            $href = str_replace( '%page%', $i, $href );
            $simple .= '<a href="' . $href . '" class="b_pages">' . $i . '</a>';
        }
    }
    if ( $page >= 1 && $page != $total_pages ) {
        $href = $link;
        if ( is_array( $params ) ) {
            foreach ( $params as $param => $value ) {
                $href = str_replace( '%' . $param . '%', $value, $href );
            }
        }
        if ( $max_page <= $total_pages ) {
            $simple .= '<div class="b_pages"> ... </div><a href="' . str_replace( '%page%', $total_pages, $href ) . '" class="b_pages" title="' . $_LANG['LAST'] . '">' . $total_pages . '</a>';
        }
    }

    $both_end = '</div></div></div>';
}

if ( in_array( $type, array( 'spiner', 'both' ) ) ) {

    if ( defined( 'VALID_CMS_ADMIN' ) ) {
        $theme = 'light';
        $GLOBALS['cp_page_head'][] = '<link rel="stylesheet" type="text/css" href="/plugins/p_pagebar/css/pagecounter_' . $theme . '.css" />';
        $GLOBALS['cp_page_head'][] = '<script type="text/javascript" src="/plugins/p_pagebar/js/pagecounter.js"></script>';
    } else {
        $this-> inPage-> addHeadCSS('plugins/p_pagebar/css/pagecounter_' . $theme . '.css');
        $this-> inPage-> addHeadJS('plugins/p_pagebar/js/pagecounter.js');
    }
}

if ( in_array( $type, array( 'simple', 'ext' ) ) ) {
    if ( defined( 'VALID_CMS_ADMIN' ) ) {
        $GLOBALS['cp_page_head'][] = '<link rel="stylesheet" type="text/css" href="/plugins/p_pagebar/css/pagecounter_' . $theme . '.css" />';
    } else {
        $this-> inPage-> addHeadCSS('plugins/p_pagebar/css/pagecounter_' . $theme . '.css');
    }
}

    $digit_len = mb_strlen( $total_pages );
    $digit_p_len = mb_strlen( $page );
    $digit_arr_rev = array_reverse( str_split( $total_pages ) );
    $digit_arr_rev_orig = str_split( $digit_len > $digit_p_len ? str_pad( $page, $digit_len, '0', STR_PAD_LEFT ) : $page );
    $digit_arr_rev_orig_max = count( $digit_arr_rev_orig );
    $digit_ignore = array_shift( $digit_arr_rev );

if ( $type == 'ext' ) {
    foreach ( $digit_arr_rev as $n => $num ) {
        if ( $page > pow( 10, $n + 1 ) ) {
            $ext_pre .= '<a href="' . str_replace( '%page%', $page - pow( 10, $n + 1 ), $href ) . '" class="b_pages">-' . pow( 10, $n + 1 ) . '</a>';
        }
        if ( $total_pages - $page >= pow( 10, $n + 1 ) ) {
            $ext_after .= '<a href="' . str_replace( '%page%', $page + pow( 10, $n + 1 ), $href ) . '" class="b_pages">+' . pow( 10, $n + 1 ) . '</a>';
        }
    }
}

if ( in_array( $type, array( 'simple', 'both' ) ) ) {
    $simple .= '</div></div></div>';
}

if ( $type == 'ext' ) {
    $ext_after .= '</div></div></div></div>';
}

if ( in_array( $type, array( 'spiner', 'both' ) ) ) {

    if ( $type == 'spiner' ) {
        $href = $link;
        if ( is_array( $params ) ) {
            foreach ( $params as $param => $value ) {
                $href = str_replace( '%' . $param . '%', $value, $href );
            }
        }
    }

$digit_len_p = mb_strlen( $page );
$digit_arr_rev_p =  str_split( str_pad( $page, $digit_len, '0', STR_PAD_LEFT ) );

$inputs = '';

$spiner .= <<<_OUT
<div id="page_counter" class="mbox">
    <button id="params_max" title="{$digit_arr_rev_orig_max}" type="button" style="display:none;height:0;width:0;"></button>
    <button id="params_href" title="{$href}" type="button" style="display:none;height:0;width:0;"></button>
    <button id="params_total" title="{$total_pages}" type="button" style="display:none;height:0;width:0;"></button>
    <div class="m_row">
_OUT;

foreach ( $digit_arr_rev_orig as $n => $num ) {
$val = $digit_arr_rev_p[$n] > 0 ? $digit_arr_rev_p[$n] : 0;
$inputs .= <<<_OUT
<div class="m_cell">
    <div class="b_act_p" id="spinPlus_{$n}">▲</div>
    <div class="b_pages_counter" id="spinPage_{$n}">{$val}</div>
    <div class="b_act_m" id="spinMinus_{$n}">▼</div>
</div>
_OUT;

}

$spiner .= <<<_OUT
<div class="m_cell">
    <div class="box">
        <div class="b_row">
                <span class="b_pages">{$page} &nbsp;&frasl;&nbsp; {$total_pages}</span>
        </div>
    </div>
</div>
_OUT;

$spiner .= $inputs;

$href_src = str_replace( '%page%', $page, $href );
$href_page_num = str_pad( $page, $digit_len, '0', STR_PAD_LEFT );
$href_width = $digit_len * 10;

$spiner .= <<<_OUT
<div class="m_cell">
    <div class="box">
        <div class="b_row">
                <span class="b_pages"> &rarr; </span>
                <a id="number" href="{$href_src}" title="{$href_page_num}" class="b_pages_current" style="width:{$href_width}px;">{$page}</a>
        </div>
    </div>
</div>

</div>
</div>
_OUT;
}

$both_end .= '</div>';

}

if ( $type == 'spiner' ) {
    $spiner .= '</div></div></div>';
    $title = '';
}

$_out = $both . $ext_pre . $simple . $ext_after . $spiner . $both_end;

$html = preg_replace( '!(\s)+!', '\\1', $_out );
$s = array( '/\>[^\S]+/', '/[^\S]+\</' );
$r = array( '>', '<', );
$html = preg_replace( $s, $r, $html );
return $html;
} // switch
} // execute
/*/_____________________________________________________________________________
¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯/*/
}