$( function(){

    $( "body" ).delegate( "div[id^='spinPlus_'], div[id^='spinMinus_']", "click", function(){

        var sel = "";

        if ( window.getSelection ) {
            sel = window.getSelection();
            sel.removeRange();
        } else if ( document.getSelection ) {
            sel = document.getSelection();
            sel.removeRange();
        } else {
            sel = document.selection.createRange().text;
            sel.empty;
        }

        var total = Number( $( "#params_total" ).attr( "title" ) );
        var max = Number( $( "#params_max" ).attr( "title" ) );
        var href = $( "#params_href" ).attr( "title" );
        var act = $( this ).is( "div[id^='spinPlus_']" ) ? "plus" : "minus";
        var p = act === "plus" ? Number( $( this ).attr( "id" ).replace( "spinPlus_", "" ) ) : Number( $( this ).attr( "id" ).replace( "spinMinus_", "" ) );
        var page = Number( $( "#number" ).attr( "title" ) );
        var p_num = Number( $( "#spinPage_" + ( p ).toString() ).text() );

        var result = compare_res( page, total, max, p, p_num, act );

        for ( var i = max; i >= 0; i-- ) {
            var finres = result.split( "" );
            var val = finres[i];
            $( "#spinPage_" + ( i ).toString() ).text( val );
        }
        href = href.replace( /\s+/, "" );
        $( "#number" ).attr( "href" , href.replace( "%page%", Number( result ) ) );
        $( "#number" ).attr( "title" , result );
        $( "#number" ).html( Number( result ) );

    });
});

function r_zero ( input, qty ) {

    if ( qty <= 0 ) { return input; }
    var res = '';
    for ( var n = 0; n < qty; ++n ) {
        res += "0";
    }
return res + input;
}

function compare_res( page, total, max, ind, pnum, act ){

    var exp = max - (ind + 1);
    var num = Math.pow( 10, exp );
    var res = ( act === "plus" ) ? page + num : page - num;
    var ofs = max - res.toString().length;
    var fin = r_zero( "1", max - 1 );

    if ( ofs > 0 && res > 0 && res <= total ) {
        fin = r_zero( res, ofs );
    } else if ( ofs == 0 && res > 0 ) {
        if ( res <= total ) {
            fin = res;
        }
        if ( res > total ) {
            fin = page;
        }
    } else if ( ofs >= 0 && res <= 0 && pnum == 0 ) {
            fin = r_zero( page, max - page.toString().length );
    }
return fin.toString();
}